
varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

uniform vec3 u_outlineColor;
uniform float u_threshold;
uniform float u_radius;

uniform sampler2D CC_Texture0;


void main()
{
    float radius = u_radius;
   
    
    vec4 accum = vec4(0.0);
    vec4 normal = vec4(0.0);
    
    normal = texture2D(CC_Texture0, vec2(v_texCoord.x, v_texCoord.y));
    
    float qual = 10.0;
    
    float t_xend = v_texCoord.x+ radius;
    float t_yend = v_texCoord.y+ radius;
    
    float step = radius*2.0/qual;
    
    for(float tx =v_texCoord.x - radius; tx < t_xend; tx+=step)
    {
        for(float ty =v_texCoord.y - radius; ty < t_yend; ty+=step)
        {
            accum += texture2D(CC_Texture0, vec2(tx,ty));
            if (accum.a > 0.0)
            {
                break;
            }
        }
    }
    
    
    //accum += texture2D(CC_Texture0, vec2(v_texCoord.x - radius, v_texCoord.y - radius));
    //accum += texture2D(CC_Texture0, vec2(v_texCoord.x + radius, v_texCoord.y - radius));
    //accum += texture2D(CC_Texture0, vec2(v_texCoord.x + radius, v_texCoord.y + radius));
    //accum += texture2D(CC_Texture0, vec2(v_texCoord.x - radius, v_texCoord.y + radius));
    
    accum *= 1.0; //u_threshold;
    
    accum.r = u_outlineColor.x;
    accum.g = u_outlineColor.y;
    accum.b = u_outlineColor.z;

    
    normal = (accum * (1.0 - normal.a)) + (normal * normal.a);
    
        
    if (normal.a < 1.0){
        normal *= 0.0;
    }
    
    gl_FragColor = v_fragmentColor*normal;
   
}